.org $4000

#include "ti83plus.inc"

.db 080h,00Fh                                        ;Field: Program length 
.db 00h,00h,00h,00h                                    ;Length=0 
.db 080h,012h                                        ;Field: Program type 
.db 01h,04h                                        ;Type= Shareware, TI-83Plus 
.db 080h,021h                                        ;Field: App ID 
.db 01h                                            ;Id = 1 
.db 080h,031h                                        ;Field: App Build 
.db 01h                                            ;Build = 1 
.db 080h,048h                                        ;Field: App Name 
.db "AltMenu "                        ;Name: "PRGM"
.db 080h, 081h                                        ;Field: Number of pages
.db 001h                                            ;Pages: 1
.db 080h, 090h                                        ;Field: Security data
.db 003h, 026h, 009h, 004h                                ;Start of security data used with signing
.db 013h, 069h, 0DBh, 04Bh
.db 002h, 00Dh, 040h, 0A1h, 06Bh, 099h, 0F6h, 059h, 0BCh, 067h
.db 0F5h, 085h, 09Ch, 009h, 06Ch, 00Fh, 0B4h, 003h, 09Bh, 0C9h
.db 003h, 032h, 02Ch, 0E0h, 003h, 020h, 0E3h, 02Ch, 0F4h, 02Dh
.db 073h, 0B4h, 027h, 0C4h, 0A0h, 072h, 054h, 0B9h, 0EAh, 07Ch
.db 03Bh, 0AAh, 016h, 0F6h, 077h, 083h, 07Ah, 0EEh, 01Ah, 0D4h
.db 042h, 04Ch, 06Bh, 08Bh, 013h, 01Fh, 0BBh, 093h, 08Bh, 0FCh
.db 019h, 01Ch, 03Ch, 0ECh, 04Dh, 0E5h, 075h                    ;End of security data used with signing
.db 80h,7Fh                                        ;Field: Program Image length 
.db 0,0,0,0                                            ;Length=0, N/A 
.db 000h, 000h, 000h, 000h                                ;padding
.db 000h, 000h, 000h, 000h                                ;padding
.db 000h, 000h, 000h, 000h                                ;padding
.db 000h, 000h, 000h, 000h                                ;padding
	jp main
	
main:
	;call clearScreen
	;bcall(_GetKey)
	;ld h, 0
	;ld l, a
	;bcall(_DispHL)
	;bcall(_NewLine)
	;bcall(_GetKey)
	;bjump(_JForceCmdNoChar)
	
	call printMenu
	
	bjump(_JForceCmdNoChar)

MEM:	
	pop bc
	ld a, skAdd+56
	ld (kbdScanCode),a
	bjump(_JForceCmdNoChar)
	
PRGM:
	pop bc
	ld a, skPrgm
	ld (kbdScanCode),a
	bjump(_JForceCmdNoChar)
	
MODE:
	pop bc
	ld a, skMode
	ld (kbdScanCode),a
	bjump(_JForceCmdNoChar)
	
	
STAT:	
	pop bc
	ld a, skStat
	ld (kbdScanCode),a
	bjump(_JForceCmdNoChar)
	
MATH:	
	pop bc
	ld a, skMath
	ld (kbdScanCode),a
	bjump(_JForceCmdNoChar)
	
VARS:	
	pop bc
	ld a, skVars
	ld (kbdScanCode),a
	bjump(_JForceCmdNoChar)
	
LIST:	
	pop bc
	ld a, skStat+56
	ld (kbdScanCode),a
	bjump(_JForceCmdNoChar)
	
DRAW:	
	pop bc
	ld a, skPrgm+56
	ld (kbdScanCode),a
	bjump(_JForceCmdNoChar)
	
STORE:	
	pop bc
	ld a, skStore
	ld (kbdScanCode),a
	bjump(_JForceCmdNoChar)
	
OFF:	
	pop bc
	;.db $3E, $01, $D3, $03, $FB, $76, $FD, $CB, $09, $A6
	bcall(_PowerOff)
	bjump(_JForceCmdNoChar)
	
LINK:
	pop bc
	ld a, skGraphvar+56
	ld (kbdScanCode),a
	bjump(_JForceCmdNoChar)
	

	
	
	
;in: hl (address of zero terminated string)
;out: prints string to the screen with newline
printString:
	push af
printStringLoop:
	ld a, (hl)
	cp 0
	jp z, printStringSkip
	bcall(_PutC)
	inc hl
	jp printStringLoop
printStringSkip:
	inc hl
	pop af
	ret
	
skipString:
	push af
skipStringLoop:
	ld a, (hl)
	cp 0
	jp z, printSilentSkip
	inc hl
	jp skipStringLoop
printSilentSkip:
	inc hl
	pop af
	ret
	
printMenu:
	ld b,0	;pos
	ld c,0
	push bc
	
printMenuVeryStart:
	call clearScreen
	ld hl, menuData
	call printString 
	call printString
	
;<top notify>
	pop bc
	ld a, 0
	cp c
	jp z, skipTopNotify1
	push bc
	push hl \ ld hl, menuTop \ call printString \ pop hl
	jp skipTopNotify2
skipTopNotify1:
	push bc
	push hl \ ld hl, menuTopFake \ call printString \ pop hl
skipTopNotify2:
;</bottom notify>
	
	pop bc
	ld a, c
	push bc
printMenuStart:
	cp 0
	jp z, printMenuStartBreak
	dec a
	call skipString
	jp printMenuStart
printMenuStartBreak:
	ld a, 0
printMenuListLoop:

	pop bc \ cp b \ call z, invertText \ push bc
	call printString
	pop bc \ cp b \ call z, invertText \ push bc
	inc a
	cp 4 \ jp nz, printMenuListLoop

printMenuListBreak:	
	
;<bottom notify>
	pop bc
	ld a, 6
	cp c
	jp z, skipBottomNotify1
	push bc
	ld hl, menuBottom
	call printString
	jp skipBottomNotify2
skipBottomNotify1:
	push bc
skipBottomNotify2:
;</bottom notify>

	bcall(_GetKey)

	cp kUp \ jp z, moveCursorUp
	cp kCapW \ jp z, moveCursorUp
	cp kDown \ jp z, moveCursorDown
	cp kCapS \ jp z, moveCursorDown
	cp k0 \ jp z, MEM
	cp k1 \	jp z, PRGM
	cp k2 \	jp z, MODE
	cp k3 \	jp z, STAT
	cp k4 \	jp z, MATH
	cp k5 \	jp z, VARS
	cp k6 \	jp z, LIST
	cp k7 \	jp z, DRAW
	cp k8 \	jp z, LINK
	cp k9 \	jp z, OFF
	cp kClear \ jp z, printMenu_kClear
	cp kQuit \ jp z, printMenu_kClear
	cp kEnter \ jp z, enterSelection
	cp kSpace \ jp z, enterSelection
	
	
	jp printMenuVeryStart
printMenu_kClear:
	pop bc
	bjump(_JForceCmdNoChar)

	ret

enterSelection:
	pop bc
	push bc
	ld a, b
	add a, c
	cp 0 \ jp z, MEM
	cp 1 \	jp z, PRGM
	cp 2 \	jp z, MODE
	cp 3 \	jp z, STAT
	cp 4 \	jp z, MATH
	cp 5 \	jp z, VARS
	cp 6 \	jp z, LIST
	cp 7 \	jp z, DRAW
	cp 8 \	jp z, LINK
	cp 9 \	jp z, OFF
	ret
	

	
moveCursorUp:
	pop bc
	ld a, 0
	cp b
	jp z, moveCursorUpSkip1
	dec b
	jp moveCursorUpSkip2
moveCursorUpSkip1:
	cp c
	jp z, moveCursorUpSkip2
	dec c
moveCursorUpSkip2:
	push bc
	ld a, 0
	jp printMenuVeryStart
	ret
	
moveCursorDown:
	pop bc
	ld a, 3
	cp b
	jp z, moveCursorDownSkip1
	inc b
	jp moveCursorDownSkip2
moveCursorDownSkip1:
	ld a, 6
	cp c
	jp z, moveCursorDownSkip2
	inc c
moveCursorDownSkip2:
	push bc
	ld a, 0
	jp printMenuVeryStart
	ret
	
invertText:
	push hl
	push af
	ld hl, 89F5h
	ld a, 8
	xor (hl)
	ld (hl), a
	pop af
	pop hl
	ret
	
clearScreen:
	ld a, 0
	ld (CurRow),a
	ld (CurCol), a
	bcall(_ClrLCDFull)
	ret

menuMax:
	.db 5
menuBegin:
	.db 2
menuData:
	.db " Select a Menu  ",0
	.db "----------------",0
	.db "0:",0C1h,"    MEM     ]",0
	.db "1:",0C1h,"    PRGM    ]",0
	.db "2:",0C1h,"    MODE    ]",0
	.db "3:",0C1h,"    STAT    ]",0
	.db "4:",0C1h,"    MATH    ]",0
	.db "5:",0C1h,"    VARS    ]",0
	.db "6:",0C1h,"    LIST    ]",0
	.db "7:",0C1h,"    DRAW    ]",0
	.db "8:",0C1h,"    LINK    ]",0
	.db "9:",0C1h,"    OFF     ]",0
	
menuBottom:
	.db $1F,"              ",$1F,0
menuTop:
	.db $1E,"              ",$1E,0
menuTopFake:
	.db "                ",0
